#include "ds1302.h"


unsigned char read_byte(unsigned char command)
{
	RTC_DDR = (1<<RTC_RST) | (1<<RTC_CLK);
	RTC_PORT |= (1<<RTC_RST);

	ds1302_write (0x81 | (command<<1));
	unsigned char temp = ds1302_read ();

	RTC_PORT &= ~(1<<RTC_RST);

	return temp;
}

void write_byte(unsigned char command, unsigned char byte)
{
	RTC_DDR = (1<<RTC_RST) | (1<<RTC_CLK);
	RTC_PORT |= (1<<RTC_RST);

	ds1302_write (0x80 | (command<<1));
	ds1302_write (byte);

	RTC_PORT &= ~(1<<RTC_RST);
}


void ds1302_write (unsigned char byte)
{
	unsigned char i;

	RTC_DDR = (1<<RTC_IO) | (1<<RTC_RST) | (1<<RTC_CLK);

	for(i = 0; i < 8; i++)
	{
		RTC_PORT &= ~(1<<RTC_IO);

		if(byte & (1<<i))
			RTC_PORT |= (1<<RTC_IO);

		RTC_PORT |= (1<<RTC_CLK);
		delay_us(2);
		RTC_PORT &= ~(1<<RTC_CLK);
		delay_us(2);
	}
}

unsigned char ds1302_read (void)
{
	unsigned char byte = 0;

	RTC_PORT &= ~(1<<RTC_IO);
	RTC_DDR &= ~(1<<RTC_IO);

	for (unsigned char i=0; i<8; i++)
	{
		if(RTC_PIN & (1<<RTC_IO))
			byte |= (1<<i);

		RTC_PORT |= (1<<RTC_CLK);
		delay_us(2);
		RTC_PORT &= ~(1<<RTC_CLK);
		delay_us(2);
	}
	return byte;
}


